#include <string.h>
#include <assert.h>
#include "citeseerparser.h"

bool
CiteseerParser::getword (word_pos &wc, char *word, FILE *fp, unsigned fsz)
{
  int c;
  unsigned wordi = 0;
  bool inword = false;
  unsigned inwordi = 0;
  bool last_is_space = false;

  while ((_output_offset || _curr_wc < _maxwordindexed) 
      && (!_output_offset || _total_off < _output_offset)
      && (!fsz || _totalc < fsz) 
      && ((c = getc(fp))!=EOF)) {

    _totalc++;

    if (c == '<') {
       _consider_skip = true;
       _skip = false;
    }
    if (_skip && !WORDCHAR(c) && c!= '.') {
       _consider_skip = _skip = false;
       inword = false;
       continue;
    } else if (_skip) {
       inword = false;
       continue;
    }

    if (_ffp && !_consider_skip) {
      if (isprint(c)) {
	 putc(c, _ffp);
	 last_is_space = (c == ' ');
	 _f_offset++;
	 _total_off++;
      } else {
	 if (!last_is_space) {
	    putc(' ', _ffp);
	    last_is_space = true;
	    _f_offset++;
	    _total_off++;
	 }
      }
    }

    if (WORDCHAR(c)) {
       /* if start with <E or <F, definitely bad*/
       if (_consider_skip && (c == 'E' || c == 'F'))
	  _skip = true;
       else if (_consider_skip) {
	  word[wordi] = '\0';
	  fputs(word, _ffp);
	  _f_offset += strlen(word);
	  _total_off += strlen(word);
	  _consider_skip = _skip = false;
       }
       if (_skip) {
	  inword = false;
	  continue;
        }
       c = tolower(c);
       if (wordi < _maxwordlen)
	  word[wordi++] = (char)c;
       if (!inword) {
	  inword = true;
	  inwordi = _total_off;
        }
    } else if (inword) {
      //output indexing information for this word
      word[wordi] = '\0';
      if (_output_offset) {
	 if (inwordi >= _output_offset)
	    return false;
	 wc = (word_pos) inwordi;
	 assert (_total_off + _last_offset == _f_offset);
      } else
	wc = _curr_wc;
      _curr_wc++;
      return true;
    }
  }
  return false;
}
