#ifndef _DOC_PARSER_H_
#define _DOC_PARSER_H_

#define DOC_UNKNOWN 0
#define DOC_HTML 1

#include "args.h"
#include "mkdb.h" 
#include <stdio.h>

using namespace std;

static inline int
xwrite (const void *xptr, int n, FILE *fp)
{
  unsigned i;
  const char *ptr = (const char *)xptr;

  for (i = 0; i < n; i++)
    if (putc(ptr[i],fp) == EOF)
      return EOF;
  return i;
}

class DocParser {

  public:
    DocParser (unsigned l, int i, FILE *logf, FILE *ffp = NULL, FILE *ffindp = NULL);
    ~DocParser () {};
    virtual unsigned parse (string fname, FILE *fp, unsigned sz = 0, DID dd = 0);
    virtual bool getword (word_pos &wc, char *word, FILE *fp, unsigned sz);
    static char which_parser (string fname);
    unsigned long long totalwords () { return _totalwords;} 
    static void setoutputoffset(unsigned s) { _output_offset = s;}

  protected:
    unsigned _maxwordlen;
    unsigned _maxwordindexed;
    unsigned long long _totalwords;

    FILE *_logfp;
    FILE *_ffp; //file to keep a forward index
    FILE *_ffindp;

    unsigned _totalc;
    unsigned _curr_wc;
    static unsigned _output_offset;
    ind_offset _f_offset;
    DID _last_dn;
    ind_offset _last_offset;
    unsigned _total_off;
};

extern DocParser* alloc_parser (string which, unsigned l, int i, FILE *f, FILE *ffp, FILE *ffindp);

#endif
