#include "docnomanager.h"
#include "filenamedocparser.h"
#include <assert.h>

/* bad jy does not match the rest of the framework, docparser, sentenceparser*/
unsigned 
FilenameDocParser::parse(string fname, FILE *fp, int sz, DID dd)
{
  DID dc;
  if (dd) 
    dc = dd;
  else {
    dc = DocNoManager::Instance()->getDocNo(fname); 
    if (!dc)
      return 0;
  }

  //write offset information to file
  if (_ffp) {
     //this is probably redundant if DIDs are always from 1..N
     assert(!_last_dn || dc == (_last_dn + 1));
     xwrite(&_f_offset, sizeof(ind_offset), _ffindp);
  }

  _last_dn = dc;

  //parse file name
  const char *name = fname.c_str();
  char c = *name;
  bool inword = false;
  char word[_maxwordlen+1]; 
  word[_maxwordlen] = '\0';

  unsigned i = 0, wordi = 0;

  //tag words appearing in filename with first bit = 1
  word_pos wc = 1 << (sizeof(word_pos)*8-1); 

  while (c!='\0') {
    c = *(name+i);
    i++;
    if (WORDCHAR(c)) {
      c = tolower(c);
      if (wordi < _maxwordlen)
	word[wordi++] = c;
      if (!inword) 
	inword = true;
    }else if (inword) {
      word[wordi] = '\0';
      fputs(word,stdout);
      putc('\0',stdout);
      xwrite(&dc,sizeof(DID),stdout);
      xwrite(&wc,sizeof(word_pos),stdout);
      wc++;
      inword = false;
      wordi = 0;
    }
  }
  DocParser::parse(fname, fp, sz, dc);
}
