#include "sentenceparser.h"


//output the locations of sentence seperator denoted by ":."
//always treat the beginning of a document with a sentence seperator
bool
SentenceParser::getword (word_pos &wc, char *word, FILE *fp, unsigned sz)
{
  int c;
  unsigned wordi = 0;
  bool inword = false;
  bool last_is_space = false;

  if (isstop) {
    wc = _curr_wc;
    _curr_wc++;
    sprintf(word, ":.");
    isstop = false;
    return true;
  }

  while ((_curr_wc < _maxwordindexed) 
      && (!_output_offset || _totalc < _output_offset)
      && (!sz || _totalc < sz) 
      && ((c = getc(fp))!=EOF)) {

    _totalc++;

    if (_ffp) {
      if (isprint(c)) {
	 putc(c, _ffp);
	 last_is_space = (c == ' ');
	 _f_offset++;
	 _total_off++;
      } else {
	 if (!last_is_space) {
	    putc(' ', _ffp);
	    last_is_space = true;
	    _f_offset++;
	    _total_off++;
	 }
      }
    }

    if (WORDCHAR(c)) {
      c = tolower(c);
      if (wordi < _maxwordlen)
	word[wordi++] = (char)c;
      if (!inword) 
	inword = true;
    } else {
      if (inword) {
	if (SENTENCESTOP (c))
	  isstop = true;
	//output indexing information for this word
	word[wordi] = '\0';
	if (_output_offset)
	  wc = (_total_off - wordi-1); 
	else
	  wc = _curr_wc;
	_curr_wc++;
	return true;
      } else if (SENTENCESTOP (c)) {
	 if (_output_offset)
	    wc = _total_off - 1;
	 else
	    wc = _curr_wc;
	_curr_wc++;
	sprintf(word, ":.");
	return true;
      }
    }
  }
  isstop = true;
  return false;
}
